/* A Bison parser, made by GNU Bison 3.3.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.3.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         mpparse
#define yylex           mplex
#define yyerror         mperror
#define yydebug         mpdebug
#define yynerrs         mpnerrs

#define yylval          mplval
#define yychar          mpchar

/* First part of user prologue.  */
#line 1 "parser.y" /* yacc.c:337  */

/*
 * Copyright 2001, THE AUTHOR <mibparser@cvtt.net>
 * All rights reserved.
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * A parser for the basic grammar to use for snmp V2c modules
 */

#ifdef _WIN32
#pragma warning(disable : 4065 4102)
#endif

/*
#ifndef __STDC__
#define __STDC__	1
#endif
*/

#define YYMALLOC	MemAlloc
#define YYFREE		MemFree

#include <nms_common.h>
#include <nms_util.h>
#include <string.h>
#include <time.h>
#include "mibparse.h"
#include "nxmibc.h"
#include "nxsnmp.h"

#define YYINCLUDED_STDLIB_H		1

#ifdef YYTEXT_POINTER
extern char *mptext;
#else
extern char mptext[];
#endif

#ifdef __64BIT__
#define YYSIZE_T  int64_t
#endif

extern FILE *mpin, *mpout;
extern int g_nCurrLine;

static MP_MODULE *m_pModule;
static MP_SYNTAX *s_currentSyntaxObject = nullptr;
#ifdef UNICODE
static char s_currentFilename[MAX_PATH];
#else
static const char *s_currentFilename;
#endif

int mperror(const char *pszMsg);
int mplex(void);
void ResetScanner();

MP_SYNTAX *create_std_syntax(int nSyntax)
{
   MP_SYNTAX *p = new MP_SYNTAX;
   p->nSyntax = nSyntax;
   return p;
}

static int AccessFromText(const char *pszText)
{
   static const char *pText[] = { "read-only", "read-write", "write-only",
                                  "not-accessible", "accessible-for-notify",
                                  "read-create", nullptr };
   for(int i = 0; pText[i] != nullptr; i++)
      if (strcmp(pszText, pText[i]))
         return i + 1;

   char szBuffer[256];
   sprintf(szBuffer, "Invalid ACCESS value \"%s\"", pszText);
   mperror(szBuffer);
   return -1;
}


#line 187 "parser.tab.cpp" /* yacc.c:337  */
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.tab.hpp".  */
#ifndef YY_MP_PARSER_TAB_HPP_INCLUDED
# define YY_MP_PARSER_TAB_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int mpdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ENTERPRISE_SYM = 258,
    TRAP_TYPE_SYM = 259,
    VARIABLES_SYM = 260,
    EXPLICIT_SYM = 261,
    IMPLICIT_SYM = 262,
    IMPLIED_SYM = 263,
    RIGHT_BRACE_SYM = 264,
    LEFT_BRACE_SYM = 265,
    RIGHT_BRACKET_SYM = 266,
    LEFT_BRACKET_SYM = 267,
    DEFINITIONS_SYM = 268,
    ASSIGNMENT_SYM = 269,
    BEGIN_SYM = 270,
    END_SYM = 271,
    FROM_SYM = 272,
    IMPORTS_SYM = 273,
    EXPORTS_SYM = 274,
    COMMA_SYM = 275,
    SEMI_COLON_SYM = 276,
    DOT_SYM = 277,
    DESCRIPTION_SYM = 278,
    ORGANIZATION_SYM = 279,
    CONTACT_SYM = 280,
    UPDATE_SYM = 281,
    MODULE_IDENTITY_SYM = 282,
    MODULE_COMPLIANCE_SYM = 283,
    OBJECT_IDENTIFIER_SYM = 284,
    OBJECT_TYPE_SYM = 285,
    OBJECT_GROUP_SYM = 286,
    OBJECT_IDENTITY_SYM = 287,
    OBJECTS_SYM = 288,
    MANDATORY_GROUPS_SYM = 289,
    GROUP_SYM = 290,
    AGENT_CAPABILITIES_SYM = 291,
    KEYWORD_SYM = 292,
    KEYWORD_VALUE_SYM = 293,
    KEYWORD_BIND_SYM = 294,
    TOKEN_SYM = 295,
    INTEGER_SYM = 296,
    INTEGER32_SYM = 297,
    UNSIGNED32_SYM = 298,
    GAUGE32_SYM = 299,
    COUNTER_SYM = 300,
    COUNTER32_SYM = 301,
    COUNTER64_SYM = 302,
    BITS_SYM = 303,
    STRING_SYM = 304,
    OCTET_SYM = 305,
    SEQUENCE_SYM = 306,
    OF_SYM = 307,
    TIMETICKS_SYM = 308,
    IP_ADDRESS_SYM = 309,
    NETWORK_ADDRESS_SYM = 310,
    OPAQUE_SYM = 311,
    REVISION_SYM = 312,
    TEXTUAL_CONVENTION_SYM = 313,
    ACCESS_SYM = 314,
    MAX_ACCESS_SYM = 315,
    MIN_ACCESS_SYM = 316,
    SYNTAX_SYM = 317,
    STATUS_SYM = 318,
    INDEX_SYM = 319,
    REFERENCE_SYM = 320,
    DEFVAL_SYM = 321,
    LEFT_PAREN_SYM = 322,
    RIGHT_PAREN_SYM = 323,
    NOTIFICATIONS_SYM = 324,
    NOTIFICATION_GROUP_SYM = 325,
    NOTIFICATION_TYPE_SYM = 326,
    SIZE_SYM = 327,
    BAR_SYM = 328,
    VARIATION_SYM = 329,
    WRITE_SYNTAX_SYM = 330,
    SUPPORTS_SYM = 331,
    INCLUDES_SYM = 332,
    CREATION_REQUIRES_SYM = 333,
    PRODUCT_RELEASE_SYM = 334,
    CHOICE_SYM = 335,
    UNITS_SYM = 336,
    AUGMENTS_SYM = 337,
    OBJECT_SYM = 338,
    TAGS_SYM = 339,
    AUTOMATIC_SYM = 340,
    MIN_SYM = 341,
    MAX_SYM = 342,
    MODULE_SYM = 343,
    MACRO_SYM = 344,
    UCASEFIRST_IDENT_SYM = 345,
    LCASEFIRST_IDENT_SYM = 346,
    BSTRING_SYM = 347,
    HSTRING_SYM = 348,
    CSTRING_SYM = 349,
    DISPLAY_HINT_SYM = 350,
    NUMBER_SYM = 351
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 116 "parser.y" /* yacc.c:352  */

   int nInteger;
   char *pszString;
   MP_NUMERIC_VALUE number;
   Array *pList;
   ObjectArray<MP_SUBID> *pOID;
   ObjectArray<MP_IMPORT_MODULE> *pImportList;
   MP_IMPORT_MODULE *pImports;
   MP_OBJECT *pObject;
   MP_SUBID *pSubId;
   MP_SYNTAX *pSyntax;

#line 340 "parser.tab.cpp" /* yacc.c:352  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE mplval;

int mpparse (void);

#endif /* !YY_MP_PARSER_TAB_HPP_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   481

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  97
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  103
/* YYNRULES -- Number of rules.  */
#define YYNRULES  226
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  433

#define YYUNDEFTOK  2
#define YYMAXUTOK   351

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   258,   258,   259,   263,   264,   268,   272,   276,   280,
     284,   288,   292,   293,   297,   301,   302,   306,   310,   311,
     315,   323,   327,   334,   346,   357,   361,   375,   382,   386,
     394,   401,   408,   418,   419,   423,   424,   431,   432,   433,
     437,   444,   451,   458,   479,   510,   529,   537,   544,   545,
     549,   550,   554,   563,   570,   577,   584,   591,   596,   602,
     609,   610,   611,   615,   616,   617,   623,   624,   625,   629,
     636,   643,   650,   655,   662,   669,   673,   677,   681,   685,
     689,   693,   707,   722,   737,   743,   749,   755,   764,   768,
     772,   776,   783,   792,   796,   800,   804,   808,   812,   816,
     820,   824,   828,   833,   837,   844,   849,   854,   859,   864,
     869,   874,   879,   884,   892,   896,   903,   912,   913,   917,
     921,   929,   930,   934,   935,   936,   948,   949,   967,   989,
    1027,  1028,  1032,  1039,  1040,  1044,  1045,  1049,  1056,  1057,
    1061,  1062,  1066,  1076,  1084,  1088,  1089,  1093,  1094,  1098,
    1117,  1135,  1149,  1150,  1154,  1160,  1164,  1168,  1169,  1173,
    1174,  1178,  1193,  1194,  1198,  1203,  1211,  1232,  1237,  1242,
    1248,  1254,  1277,  1278,  1282,  1289,  1296,  1300,  1304,  1308,
    1309,  1310,  1314,  1318,  1319,  1323,  1327,  1328,  1332,  1336,
    1340,  1347,  1354,  1361,  1365,  1373,  1383,  1387,  1395,  1399,
    1403,  1410,  1418,  1419,  1423,  1427,  1428,  1432,  1433,  1437,
    1444,  1445,  1446,  1447,  1448,  1449,  1450,  1454,  1455,  1456,
    1457,  1464,  1468,  1475,  1482,  1489,  1493
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ENTERPRISE_SYM", "TRAP_TYPE_SYM",
  "VARIABLES_SYM", "EXPLICIT_SYM", "IMPLICIT_SYM", "IMPLIED_SYM",
  "RIGHT_BRACE_SYM", "LEFT_BRACE_SYM", "RIGHT_BRACKET_SYM",
  "LEFT_BRACKET_SYM", "DEFINITIONS_SYM", "ASSIGNMENT_SYM", "BEGIN_SYM",
  "END_SYM", "FROM_SYM", "IMPORTS_SYM", "EXPORTS_SYM", "COMMA_SYM",
  "SEMI_COLON_SYM", "DOT_SYM", "DESCRIPTION_SYM", "ORGANIZATION_SYM",
  "CONTACT_SYM", "UPDATE_SYM", "MODULE_IDENTITY_SYM",
  "MODULE_COMPLIANCE_SYM", "OBJECT_IDENTIFIER_SYM", "OBJECT_TYPE_SYM",
  "OBJECT_GROUP_SYM", "OBJECT_IDENTITY_SYM", "OBJECTS_SYM",
  "MANDATORY_GROUPS_SYM", "GROUP_SYM", "AGENT_CAPABILITIES_SYM",
  "KEYWORD_SYM", "KEYWORD_VALUE_SYM", "KEYWORD_BIND_SYM", "TOKEN_SYM",
  "INTEGER_SYM", "INTEGER32_SYM", "UNSIGNED32_SYM", "GAUGE32_SYM",
  "COUNTER_SYM", "COUNTER32_SYM", "COUNTER64_SYM", "BITS_SYM",
  "STRING_SYM", "OCTET_SYM", "SEQUENCE_SYM", "OF_SYM", "TIMETICKS_SYM",
  "IP_ADDRESS_SYM", "NETWORK_ADDRESS_SYM", "OPAQUE_SYM", "REVISION_SYM",
  "TEXTUAL_CONVENTION_SYM", "ACCESS_SYM", "MAX_ACCESS_SYM",
  "MIN_ACCESS_SYM", "SYNTAX_SYM", "STATUS_SYM", "INDEX_SYM",
  "REFERENCE_SYM", "DEFVAL_SYM", "LEFT_PAREN_SYM", "RIGHT_PAREN_SYM",
  "NOTIFICATIONS_SYM", "NOTIFICATION_GROUP_SYM", "NOTIFICATION_TYPE_SYM",
  "SIZE_SYM", "BAR_SYM", "VARIATION_SYM", "WRITE_SYNTAX_SYM",
  "SUPPORTS_SYM", "INCLUDES_SYM", "CREATION_REQUIRES_SYM",
  "PRODUCT_RELEASE_SYM", "CHOICE_SYM", "UNITS_SYM", "AUGMENTS_SYM",
  "OBJECT_SYM", "TAGS_SYM", "AUTOMATIC_SYM", "MIN_SYM", "MAX_SYM",
  "MODULE_SYM", "MACRO_SYM", "UCASEFIRST_IDENT_SYM",
  "LCASEFIRST_IDENT_SYM", "BSTRING_SYM", "HSTRING_SYM", "CSTRING_SYM",
  "DISPLAY_HINT_SYM", "NUMBER_SYM", "$accept", "ModuleDefinition",
  "AssignmentList", "Assignment", "ModuleIdentifierAssignment",
  "ModuleIdentifier", "ObjectIdentifierAssignment", "AssignedIdentifier",
  "AssignedIdentifierList", "ObjectIdentifierList", "ObjectIdentifier",
  "NumericValue", "NumberOrMinMax", "DefinedValue", "Number",
  "ObjectIdentityAssignment", "ObjectTypeAssignment",
  "ModuleIdentityAssignment", "ImportsAssignment", "ExportsAssignment",
  "SnmpRevisionPart", "SnmpRevisionList", "SnmpRevisionObject",
  "SnmpIdentityPart", "SnmpOrganisationPart", "SnmpContactInfoPart",
  "SnmpUpdatePart", "SnmpDescriptionPart", "SnmpDescriptionStatement",
  "ValueConstraint", "NumericValueConstraintList", "SnmpKeywordAssignment",
  "SnmpKeywordName", "SnmpKeywordValue", "SnmpKeywordBinding",
  "SnmpSyntaxPart", "SnmpSyntaxStatement", "SnmpUnitsPart",
  "SnmpWriteSyntaxPart", "SnmpCreationPart", "TypeOrValueAssignment",
  "Type", "NamedType", "BuiltInType", "BuiltInTypeAssignment",
  "TypeOrTextualConvention", "MacroAssignment", "TokenList", "TokenObject",
  "TextualConventionAssignment", "TextualConventionDefinition",
  "TextualConventionDefinitionElement", "SnmpNotificationTypeAssignment",
  "SnmpTrapVariablePart", "SnmpTrapVariableList", "SnmpMandatoryGroupPart",
  "SnmpMandatoryGroupList", "SnmpMandatoryGroup", "SnmpCompliancePart",
  "SnmpComplianceList", "SnmpComplianceObject", "SnmpObjectsPart",
  "SnmpObjectGroupAssignment", "SnmpNotificationGroupAssignment",
  "ModuleComplianceAssignment", "SnmpModuleComplianceList",
  "SnmpModuleComplianceObject", "OptionalModuleName",
  "SnmpVariationsListPart", "SnmpVariationsList", "SnmpVariationPart",
  "ModuleCapabilitiesList", "ModuleCapabilitiesAssignment",
  "AgentCapabilitiesAssignment", "SnmpAccessPart", "SnmpStatusPart",
  "SnmpReferencePart", "SnmpReferenceStatement",
  "SnmpDisplayHintStatement", "SnmpIndexPart", "SnmpDefValPart",
  "DefValList", "DefValListElement", "BinaryString", "HexString",
  "CharString", "SymbolsFromModuleList", "SymbolsFromModule", "SymbolList",
  "Symbol", "SequenceItem", "SequenceList", "SequenceAssignment",
  "SnmpTypeTagPart", "SnmpTypeTagList", "SnmpTypeTagItem",
  "OctetStringType", "Value", "Identifier", "UCidentifier", "LCidentifier",
  "End", "Begin", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351
};
# endif

#define YYPACT_NINF -346

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-346)))

#define YYTABLE_NINF -223

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -38,  -346,    73,   390,  -346,    66,  -346,  -346,    41,    41,
      50,    69,   112,   124,   162,   167,   183,   211,   216,   228,
     231,  -346,   390,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
     140,  -346,   104,  -346,  -346,  -346,  -346,  -346,  -346,  -346,
    -346,    27,   232,   195,  -346,   240,   136,    26,  -346,   168,
    -346,  -346,  -346,   200,   158,    14,    14,    14,    14,    14,
      14,    14,    14,    14,   241,  -346,  -346,   158,   236,   247,
     250,  -346,   254,   263,   256,   242,   246,    13,   155,    18,
    -346,   246,    13,   226,    13,  -346,    -4,  -346,  -346,  -346,
     -38,    41,  -346,  -346,  -346,   -38,   258,   176,  -346,    23,
      23,  -346,  -346,   349,   299,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,   275,  -346,   158,   291,   158,
     307,  -346,   136,    19,  -346,    24,   237,  -346,   136,   296,
     310,   311,   213,   126,   312,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,   185,   312,  -346,  -346,   296,
     246,   158,   246,   243,  -346,  -346,  -346,   229,   299,   158,
     158,   158,  -346,  -346,   176,  -346,  -346,  -346,  -346,   192,
     172,  -346,  -346,   274,    17,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,   277,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,  -346,  -346,  -346,    46,  -346,  -346,   158,   296,
    -346,    41,   323,  -346,   158,   213,  -346,   264,  -346,    29,
      32,   136,   136,   136,   246,   212,  -346,  -346,    16,  -346,
    -346,  -346,   266,   308,   267,  -346,   264,   296,   246,   296,
     241,   325,  -346,   212,  -346,  -346,  -346,  -346,  -346,  -346,
      28,   316,  -346,  -346,   330,   273,   276,   278,   292,  -346,
     293,  -346,  -346,  -346,  -346,   287,    51,   335,   296,  -346,
    -346,   246,   256,  -346,  -346,   130,  -346,   152,  -346,  -346,
    -346,   296,  -346,   154,    24,  -346,  -346,   229,   136,   259,
     264,   296,   264,  -346,  -346,   192,   192,   326,  -346,   109,
     192,  -346,  -346,  -346,   158,   256,   287,  -346,  -346,    41,
     264,   296,  -346,  -346,  -346,   264,  -346,   212,  -346,   282,
    -346,   -38,     6,  -346,   256,   264,   256,  -346,  -346,   109,
     284,   286,   296,  -346,  -346,   164,   256,   264,   256,  -346,
    -346,   327,  -346,  -346,  -346,  -346,    72,  -346,  -346,  -346,
     294,  -346,  -346,  -346,    77,  -346,   353,     9,   327,  -346,
     -38,   288,    21,  -346,  -346,   354,   356,   301,    41,   136,
     136,  -346,     9,  -346,  -346,   295,    41,  -346,  -346,    41,
     212,   358,   256,   166,   296,   242,  -346,   360,     4,   170,
     364,   308,  -346,    64,  -346,  -346,  -346,  -346,   300,    41,
     136,  -346,   302,  -346,  -346,  -346,    34,   365,   357,   370,
     372,   376,    10,    24,   213,   173,   242,  -346,  -346,   174,
    -346,   378,  -346,  -346,  -346,  -346,  -346,   296,   302,   300,
    -346,  -346,  -346,  -346,   213,   320,   391,   301,    41,   296,
     220,  -346,  -346
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   223,     0,     0,    20,     0,     1,   225,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,     0,     5,     6,     7,     8,    17,    18,    19,
       0,    15,    66,    10,    81,     9,    11,    14,    13,    12,
      16,     0,   221,   222,     3,     0,     0,     0,   194,     0,
     197,   198,   199,     0,     0,   206,   206,   206,   206,   206,
     206,   206,   206,   206,     0,     4,     2,     0,     0,     0,
       0,    67,     0,     0,     0,    73,     0,   148,   206,     0,
      53,     0,   148,     0,   148,    24,     0,   200,    46,   193,
       0,     0,    47,   192,    69,     0,     0,     0,   114,    89,
      88,   107,   115,     0,   205,   208,   108,   113,   110,   111,
     112,   109,   105,   106,   226,     0,    56,     0,     0,     0,
       0,    68,     0,     0,    23,   206,    76,    72,     0,    58,
       0,     0,   170,     0,     0,   190,   191,    42,   217,    83,
      82,   219,   218,   220,    87,     0,     0,    25,    26,    58,
       0,     0,     0,     0,    21,   195,   196,     0,   206,     0,
       0,     0,   125,   127,   120,   122,   124,   126,   123,     0,
       0,    91,    90,     0,     0,   103,    93,    95,    96,   100,
      97,    98,    99,   216,     0,   101,   213,   214,   215,   104,
      92,   221,   222,   207,   119,     0,   118,    54,     0,    58,
      70,     0,   131,    74,     0,   170,   171,   173,    57,     0,
       0,     0,     0,     0,     0,     0,    84,    86,     0,    29,
      31,    30,     0,   221,    41,    85,   173,    58,     0,    58,
       0,     0,   102,     0,    59,   174,   175,   121,    38,    39,
      65,    33,    34,    37,     0,     0,     0,     0,     0,    94,
       0,   210,   117,   116,    55,    49,     0,     0,    58,   130,
      75,     0,     0,   172,   145,     0,   147,     0,   167,   168,
     169,    58,   202,     0,   206,    27,    28,     0,     0,     0,
     173,    58,   173,    22,   209,     0,     0,     0,    62,     0,
       0,    60,   211,   212,     0,     0,    48,    51,    71,     0,
     173,    58,    43,   144,   146,   173,   204,     0,   201,     0,
      40,   156,     0,   153,     0,   173,     0,    64,    63,     0,
       0,     0,    58,    45,    50,     0,     0,   173,     0,   203,
      32,   134,   155,   151,   152,   149,     0,   150,    35,    36,
       0,    52,   132,   129,   178,   128,     0,   139,   133,   136,
       0,     0,     0,   163,    61,     0,     0,   185,     0,     0,
       0,   154,   138,   141,   135,     0,     0,   166,   162,     0,
       0,     0,     0,     0,    58,    73,   140,     0,   158,     0,
       0,     0,    41,     0,   184,    44,   137,   143,    78,     0,
       0,   165,   157,   160,   176,   177,     0,     0,   187,     0,
       0,     0,     0,   206,   170,     0,    73,   159,   189,     0,
     183,     0,   179,   180,   181,   182,    77,    58,   158,    78,
     188,   186,   142,   164,   170,    80,     0,   185,     0,    58,
       0,   161,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -346,  -346,  -346,   385,  -346,   386,  -346,   -59,    39,  -346,
     182,  -346,  -239,  -133,   -69,  -346,  -346,  -346,  -346,  -346,
    -346,  -346,   115,  -346,  -346,  -346,  -346,   -94,   -80,   313,
    -156,  -346,  -346,   340,  -346,  -345,   -65,  -346,    -5,  -346,
    -346,   -72,   257,  -346,  -346,   238,  -346,  -346,   221,   339,
    -346,   260,  -346,  -346,  -346,  -346,  -346,    70,  -346,  -346,
      58,   107,  -346,  -346,  -346,  -346,   110,  -346,     3,  -346,
      31,  -346,    74,  -346,  -200,   -63,  -187,   -27,  -346,  -346,
      -2,    20,  -346,    45,    47,   -51,  -346,   382,    -9,   347,
     134,  -346,   -83,   289,  -346,   338,  -346,  -346,     0,     1,
      -1,   -15,   -78
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    22,    23,     3,   351,    24,    85,   147,   218,
     219,   240,   241,   242,   243,    25,    26,    27,    28,    29,
     295,   296,   297,    30,   118,   199,    68,   207,   208,   171,
     244,    31,    32,    71,    72,   126,   127,   205,   404,   427,
      33,    98,    99,   100,    34,   101,    35,   195,   196,   102,
     164,   165,    36,   258,   259,   347,   348,   349,   361,   362,
     363,   132,    37,    38,    39,   312,   313,   331,   391,   392,
     393,   352,   353,    40,   214,   166,   262,   263,   168,   357,
     372,   397,   398,   141,   142,    94,    47,    48,    49,    50,
     272,   273,   216,   103,   104,   105,   189,   144,   245,    51,
      52,    44,   115
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      53,     5,    43,    41,    42,   261,   139,    66,   154,   138,
     148,   114,   220,   129,   247,   124,   116,   162,   149,   415,
     123,    43,    41,    42,    91,   275,    95,   143,   145,   145,
     388,    73,   163,   169,    46,   123,    95,    46,   264,   279,
      46,   266,    46,   408,   359,    87,   130,    88,   285,    46,
     320,   217,     1,   203,   148,   226,    74,    75,   249,    76,
     298,   419,     7,   225,    54,    96,   197,   250,   200,   146,
     167,    91,    97,     6,   396,    96,   221,   277,   390,    45,
     338,   153,   131,    55,   162,   220,   194,   227,   231,   229,
     170,   155,   360,   314,   311,   316,   157,   350,    77,   163,
     228,   286,   192,   190,   191,   255,     1,    21,   234,   235,
     236,     1,   137,   326,   137,   137,     1,    21,   328,     1,
      21,   202,     1,    21,     1,    21,    56,   206,   336,   317,
     318,     1,    21,   280,   321,   282,   215,   167,    57,   303,
     344,   355,    69,    70,   224,   222,   223,   254,   350,   221,
      91,   271,   283,   260,     1,    21,   135,   136,    93,   356,
     137,   304,     1,   306,   300,   281,    67,    95,   224,   224,
     223,   223,    91,   342,   307,   386,    58,   305,   158,   394,
     253,    59,   418,   420,    91,    90,    91,   315,    91,   150,
      91,   152,   256,    91,    91,   238,   239,    60,   301,   159,
     265,   267,   308,   302,   417,   137,   133,   327,   309,    79,
     268,   269,   270,    97,   192,   274,   191,   224,   222,   223,
      91,    92,    80,    81,   425,    61,    82,    21,   341,   432,
      62,    83,   192,   190,   191,   134,   323,   380,   125,   128,
      91,   160,    63,   322,   246,    64,    78,   135,   136,    93,
     220,   137,    93,   333,    86,   335,   114,   337,   238,   239,
     117,   119,     1,    21,   120,    84,   122,   343,   137,   345,
     123,   161,   211,   212,   213,     1,    21,   310,   238,   239,
     387,   137,     1,    21,   224,   224,   223,   223,   137,   224,
     325,   223,    69,   367,   106,   107,   108,   109,   110,   111,
     112,   113,     1,    21,   125,   151,   192,   274,   191,   128,
     158,    95,   332,   385,   221,   194,   198,   201,   204,   159,
     209,   210,   215,   422,   248,   137,   251,   230,   257,   160,
     278,   416,   401,   277,  -222,   431,   284,     5,   287,   288,
     289,   292,   293,   290,   294,   299,   291,   311,   319,   373,
     330,   365,   339,     5,   340,   173,   174,   378,   374,   375,
     379,   346,   354,   358,   369,   366,   370,   371,   383,   382,
     389,   381,   377,   395,   410,   403,   390,   411,   175,   412,
     405,   413,   224,   402,   223,   414,     4,   409,   396,   406,
     176,   177,   178,   179,   180,   181,   182,   183,   426,   184,
     276,   428,   185,   186,   187,   188,     7,    65,     8,     9,
     384,   324,   121,   172,   424,   232,   252,   140,   364,   430,
     376,   423,   334,   407,   237,   429,   368,    10,   399,    89,
     400,   421,    11,    12,    13,    14,    15,    16,   156,     1,
      21,   329,   193,    17,    18,     0,    19,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       1,    21
};

static const yytype_int16 yycheck[] =
{
       9,     0,     3,     3,     3,   205,    78,    22,    86,    78,
      79,    15,   145,    76,   170,    74,    67,    97,    81,     9,
      14,    22,    22,    22,    20,     9,    12,    78,    10,    10,
     375,     4,    97,    10,     8,    14,    12,     8,     9,   226,
       8,     9,     8,     9,    35,    46,    33,    21,    20,     8,
     289,   134,    90,   125,   123,   149,    29,    30,    41,    32,
       9,   406,    16,   146,    14,    51,   117,    50,   119,    51,
      97,    20,    58,     0,    10,    51,   145,    67,    74,    13,
     319,    85,    69,    14,   164,   218,    40,   150,   157,   152,
      67,    90,    83,   280,    88,   282,    95,    76,    71,   164,
     151,    73,   103,   103,   103,   199,    90,    91,   159,   160,
     161,    90,    96,   300,    96,    96,    90,    91,   305,    90,
      91,   122,    90,    91,    90,    91,    14,   128,   315,   285,
     286,    90,    91,   227,   290,   229,    10,   164,    14,     9,
     327,    64,    38,    39,   145,   145,   145,   198,    76,   218,
      20,   214,   230,   204,    90,    91,    92,    93,    94,    82,
      96,     9,    90,     9,   258,   228,    26,    12,   169,   170,
     169,   170,    20,     9,    20,     9,    14,   271,    52,     9,
     195,    14,     9,     9,    20,    17,    20,   281,    20,    82,
      20,    84,   201,    20,    20,    86,    87,    14,   261,    23,
     209,   210,   274,   262,   404,    96,    51,   301,   277,    14,
     211,   212,   213,    58,   215,   215,   215,   218,   218,   218,
      20,    21,    27,    28,   424,    14,    31,    91,   322,     9,
      14,    36,   233,   233,   233,    80,   295,   370,    62,    63,
      20,    65,    14,   294,    72,    14,    14,    92,    93,    94,
     383,    96,    94,   312,    14,   314,    15,   316,    86,    87,
      24,    14,    90,    91,    14,    70,     3,   326,    96,   328,
      14,    95,    59,    60,    61,    90,    91,   278,    86,    87,
     374,    96,    90,    91,   285,   286,   285,   286,    96,   290,
     299,   290,    38,   352,    56,    57,    58,    59,    60,    61,
      62,    63,    90,    91,    62,    79,   307,   307,   307,    63,
      52,    12,   311,   372,   383,    40,    25,    10,    81,    23,
      10,    10,    10,   417,    50,    96,    49,    84,     5,    65,
      22,   403,   383,    67,    67,   429,    11,   336,    22,     9,
      67,    49,    49,    67,    57,    10,    68,    88,    22,   358,
      68,   350,    68,   352,    68,     6,     7,   366,   359,   360,
     369,    34,    68,    10,    10,    77,    10,    66,    10,   370,
      10,   370,    77,     9,     9,    75,    74,    20,    29,     9,
     389,     9,   383,   383,   383,     9,     0,   396,    10,   390,
      41,    42,    43,    44,    45,    46,    47,    48,    78,    50,
     218,    10,    53,    54,    55,    56,    16,    22,    18,    19,
     371,   296,    72,   100,   419,   158,   195,    78,   348,   428,
     362,   418,   312,   392,   164,   427,   352,    37,   383,    47,
     383,   411,    42,    43,    44,    45,    46,    47,    91,    90,
      91,   307,   104,    53,    54,    -1,    56,   158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    91
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    90,    98,   101,   102,   196,     0,    16,    18,    19,
      37,    42,    43,    44,    45,    46,    47,    53,    54,    56,
      89,    91,    99,   100,   103,   112,   113,   114,   115,   116,
     120,   128,   129,   137,   141,   143,   149,   159,   160,   161,
     170,   195,   196,   197,   198,    13,     8,   183,   184,   185,
     186,   196,   197,   185,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,   100,   198,    26,   123,    38,
      39,   130,   131,     4,    29,    30,    32,    71,    14,    14,
      27,    28,    31,    36,    70,   104,    14,   197,    21,   184,
      17,    20,    21,    94,   182,    12,    51,    58,   138,   139,
     140,   142,   146,   190,   191,   192,   142,   142,   142,   142,
     142,   142,   142,   142,    15,   199,   182,    24,   121,    14,
      14,   130,     3,    14,   104,    62,   132,   133,    63,   172,
      33,    69,   158,    51,    80,    92,    93,    96,   111,   138,
     146,   180,   181,   182,   194,    10,    51,   105,   111,   172,
     158,    79,   158,    85,   199,   196,   186,   196,    52,    23,
      65,    95,   125,   133,   147,   148,   172,   174,   175,    10,
      67,   126,   126,     6,     7,    29,    41,    42,    43,    44,
      45,    46,    47,    48,    50,    53,    54,    55,    56,   193,
     195,   196,   197,   192,    40,   144,   145,   182,    25,   122,
     182,    10,   197,   138,    81,   134,   197,   124,   125,    10,
      10,    59,    60,    61,   171,    10,   189,   189,   106,   107,
     110,   111,   195,   196,   197,   189,   124,   172,   182,   172,
      84,   111,   139,   190,   182,   182,   182,   148,    86,    87,
     108,   109,   110,   111,   127,   195,    72,   127,    50,    41,
      50,    49,   145,   198,   182,   124,   185,     5,   150,   151,
     182,   171,   173,   174,     9,   185,     9,   185,   197,   197,
     197,   172,   187,   188,   195,     9,   107,    67,    22,   173,
     124,   172,   124,   199,    11,    20,    73,    22,     9,    67,
      67,    68,    49,    49,    57,   117,   118,   119,     9,    10,
     124,   172,   104,     9,     9,   124,     9,    20,   138,   111,
     197,    88,   162,   163,   173,   124,   173,   127,   127,    22,
     109,   127,   182,   104,   119,   185,   173,   124,   173,   187,
      68,   164,   196,   104,   163,   104,   173,   104,   109,    68,
      68,   124,     9,   104,   173,   104,    34,   152,   153,   154,
      76,   102,   168,   169,    68,    64,    82,   176,    10,    35,
      83,   155,   156,   157,   154,   196,    77,   104,   169,    10,
      10,    66,   177,   185,   197,   197,   157,    77,   185,   185,
     110,   196,   197,    10,   105,   104,     9,   124,   132,    10,
      74,   165,   166,   167,     9,     9,    10,   178,   179,   180,
     181,   182,   195,    75,   135,   185,   197,   167,     9,   185,
       9,    20,     9,     9,     9,     9,   138,   171,     9,   132,
       9,   178,   124,   165,   135,   171,    78,   136,    10,   177,
     185,   124,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    97,    98,    98,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     101,   102,   102,   103,   103,   104,   104,   105,   106,   106,
     107,   107,   107,   108,   108,   108,   108,   109,   109,   109,
     110,   110,   111,   112,   113,   114,   115,   116,   117,   117,
     118,   118,   119,   120,   121,   122,   123,   124,   124,   125,
     126,   126,   126,   127,   127,   127,   128,   128,   128,   129,
     130,   131,   132,   132,   133,   134,   134,   135,   135,   136,
     136,   137,   137,   137,   137,   137,   137,   137,   138,   138,
     138,   138,   139,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   142,   142,   143,   144,   144,   145,
     146,   147,   147,   148,   148,   148,   148,   148,   149,   149,
     150,   150,   151,   152,   152,   153,   153,   154,   155,   155,
     156,   156,   157,   157,   158,   158,   158,   158,   158,   159,
     160,   161,   162,   162,   163,   164,   164,   165,   165,   166,
     166,   167,   168,   168,   169,   169,   170,   171,   171,   171,
     171,   172,   173,   173,   174,   175,   176,   176,   176,   177,
     177,   177,   177,   177,   177,   177,   178,   178,   179,   179,
     180,   181,   182,   183,   183,   184,   185,   185,   186,   186,
     186,   187,   188,   188,   189,   190,   190,   191,   191,   192,
     193,   193,   193,   193,   193,   193,   193,   194,   194,   194,
     194,   195,   195,   196,   197,   198,   199
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     6,     3,     2,     2,     2,     3,     2,     1,
       1,     1,     4,     1,     1,     4,     4,     1,     1,     1,
       3,     1,     1,     6,    11,     7,     3,     3,     1,     0,
       2,     1,     3,     2,     2,     2,     2,     1,     0,     2,
       3,     6,     3,     3,     3,     1,     1,     2,     3,     3,
       3,     5,     1,     0,     2,     2,     0,     2,     0,     4,
       0,     1,     3,     3,     4,     4,     4,     3,     1,     1,
       2,     2,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     5,     2,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     8,     8,
       1,     0,     4,     1,     0,     2,     1,     4,     1,     0,
       2,     1,     6,     3,     4,     3,     4,     3,     0,     7,
       7,     7,     2,     1,     4,     1,     0,     1,     0,     2,
       1,     8,     2,     1,     7,     4,     9,     2,     2,     2,
       0,     2,     1,     0,     2,     2,     4,     4,     0,     4,
       4,     4,     4,     4,     2,     0,     3,     1,     3,     2,
       1,     1,     1,     2,     1,     3,     3,     1,     1,     1,
       2,     2,     1,     3,     3,     1,     0,     2,     1,     4,
       2,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 269 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1810 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 7:
#line 273 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1818 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 8:
#line 277 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1826 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 9:
#line 281 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1834 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 10:
#line 285 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1842 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 11:
#line 289 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1850 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 13:
#line 294 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1858 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 14:
#line 298 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1866 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 16:
#line 303 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1874 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 17:
#line 307 "parser.y" /* yacc.c:1652  */
    {
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1882 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 20:
#line 316 "parser.y" /* yacc.c:1652  */
    {
   m_pModule = new MP_MODULE;
   m_pModule->pszName = (yyvsp[0].pszString);
}
#line 1891 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 21:
#line 324 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[-3].pszString);
}
#line 1899 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 22:
#line 328 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[-5].pszString);
}
#line 1907 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 23:
#line 335 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 1923 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 24:
#line 347 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-1].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 1935 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 25:
#line 358 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pOID) = (yyvsp[0].pOID);
}
#line 1943 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 26:
#line 362 "parser.y" /* yacc.c:1652  */
    {
   MP_SUBID *subid;

   subid = new MP_SUBID;
   subid->dwValue = (yyvsp[0].number).value.nInt32;
   subid->pszName = NULL;
   subid->bResolved = TRUE;
   (yyval.pOID) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.pOID)->add(subid);
}
#line 1958 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 27:
#line 376 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pOID) = (yyvsp[-1].pOID);
}
#line 1966 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 28:
#line 383 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pOID)->add((yyvsp[0].pSubId));
}
#line 1974 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 29:
#line 387 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pOID) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.pOID)->add((yyvsp[0].pSubId));
}
#line 1983 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 30:
#line 395 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[0].number).value.nInt32;
   (yyval.pSubId)->pszName = NULL;
   (yyval.pSubId)->bResolved = TRUE;
}
#line 1994 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 31:
#line 402 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = 0;
   (yyval.pSubId)->pszName = (yyvsp[0].pszString);
   (yyval.pSubId)->bResolved = FALSE;
}
#line 2005 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 32:
#line 409 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[-1].number).value.nInt32;
   (yyval.pSubId)->pszName = (yyvsp[-3].pszString);
   (yyval.pSubId)->bResolved = TRUE;
}
#line 2016 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 34:
#line 420 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2024 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 36:
#line 425 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-3].pszString));
}
#line 2032 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 40:
#line 438 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (char *)MemAlloc(strlen((yyvsp[-2].pszString)) + strlen((yyvsp[0].pszString)) + 2);
   sprintf((yyval.pszString), "%s.%s", (yyvsp[-2].pszString), (yyvsp[0].pszString));
   MemFree((yyvsp[-2].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2043 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 41:
#line 445 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2051 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 42:
#line 452 "parser.y" /* yacc.c:1652  */
    {
   (yyval.number) = (yyvsp[0].number);
}
#line 2059 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 43:
#line 463 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-5].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2077 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 44:
#line 489 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-10].pszString);
   (yyval.pObject)->iSyntax = (yyvsp[-8].pSyntax)->nSyntax;
   (yyval.pObject)->pszDataType = (yyvsp[-8].pSyntax)->pszStr;
   (yyvsp[-8].pSyntax)->pszStr = NULL;
   delete (yyvsp[-8].pSyntax);
   (yyval.pObject)->iAccess = (yyvsp[-6].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-5].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-4].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2100 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 45:
#line 517 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->iSyntax = MIB_TYPE_MODID;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2114 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 46:
#line 530 "parser.y" /* yacc.c:1652  */
    {
	delete m_pModule->pImportList;
   m_pModule->pImportList = (yyvsp[-1].pImportList);
}
#line 2123 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 47:
#line 538 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2131 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 52:
#line 556 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2140 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 53:
#line 564 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[-1].pszString);
}
#line 2148 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 54:
#line 571 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2156 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 55:
#line 578 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2164 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 56:
#line 585 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2172 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 57:
#line 592 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2180 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 58:
#line 596 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = nullptr;
}
#line 2188 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 59:
#line 603 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2196 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 65:
#line 618 "parser.y" /* yacc.c:1652  */
    {
}
#line 2203 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 69:
#line 630 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2211 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 70:
#line 637 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2219 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 71:
#line 644 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2227 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 72:
#line 651 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2235 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 73:
#line 655 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = MIB_TYPE_OTHER;
}
#line 2244 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 74:
#line 663 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2252 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 75:
#line 670 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2260 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 77:
#line 678 "parser.y" /* yacc.c:1652  */
    {
	delete (yyvsp[0].pSyntax);
}
#line 2268 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 79:
#line 686 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2276 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 81:
#line 694 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->pszName = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2294 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 82:
#line 708 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TEXTUAL_CONVENTION;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2313 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 83:
#line 723 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   if ((yyvsp[0].pSyntax) != NULL)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = NULL;
      (yyvsp[0].pSyntax)->pszDescription = NULL;
      delete (yyvsp[0].pSyntax);
   }
}
#line 2332 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 84:
#line 738 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2342 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 85:
#line 744 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2352 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 86:
#line 750 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_CHOICE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
}
#line 2362 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 87:
#line 756 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_VALUE;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
}
#line 2372 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 88:
#line 765 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2380 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 89:
#line 769 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2388 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 90:
#line 773 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2396 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 91:
#line 777 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2404 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 92:
#line 784 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = -1;
   (yyval.pSyntax)->pszStr = (yyvsp[0].pszString);
}
#line 2414 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 93:
#line 793 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2422 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 94:
#line 797 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2430 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 95:
#line 801 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
}
#line 2438 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 96:
#line 805 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
}
#line 2446 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 97:
#line 809 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
}
#line 2454 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 98:
#line 813 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
}
#line 2462 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 99:
#line 817 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
}
#line 2470 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 100:
#line 821 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
}
#line 2478 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 101:
#line 825 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
}
#line 2486 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 102:
#line 829 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_SEQUENCE);
   delete (yyvsp[0].pSyntax);
}
#line 2495 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 103:
#line 834 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OBJID);
}
#line 2503 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 104:
#line 838 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OCTETSTR);
}
#line 2511 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 105:
#line 845 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_IPADDR);
   (yyval.pSyntax)->pszStr = MemCopyStringA("IpAddress");
}
#line 2520 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 106:
#line 850 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OPAQUE);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Opaque");
}
#line 2529 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 107:
#line 855 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Integer32");
}
#line 2538 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 108:
#line 860 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Unsigned32");
}
#line 2547 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 109:
#line 865 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
   (yyval.pSyntax)->pszStr = MemCopyStringA("TimeTicks");
}
#line 2556 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 110:
#line 870 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter");
}
#line 2565 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 111:
#line 875 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter32");
}
#line 2574 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 112:
#line 880 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter64");
}
#line 2583 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 113:
#line 885 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Gauge32");
}
#line 2592 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 114:
#line 893 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[0].pSyntax);
}
#line 2600 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 115:
#line 897 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[0].pSyntax);
}
#line 2608 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 116:
#line 904 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_MACRO;
   (yyval.pObject)->pszName = (yyvsp[-4].pszString);
}
#line 2618 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 120:
#line 922 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pSyntax) = s_currentSyntaxObject;
   s_currentSyntaxObject = nullptr;
}
#line 2627 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 125:
#line 937 "parser.y" /* yacc.c:1652  */
    {
	if (s_currentSyntaxObject != nullptr)
	{
		MemFree(s_currentSyntaxObject->pszDescription);
	}
	else
	{
		s_currentSyntaxObject = new MP_SYNTAX();
	}
	s_currentSyntaxObject->pszDescription = (yyvsp[0].pszString);
}
#line 2643 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 127:
#line 950 "parser.y" /* yacc.c:1652  */
    {
	if (s_currentSyntaxObject != nullptr)
	{
		s_currentSyntaxObject->nSyntax = (yyvsp[0].pSyntax)->nSyntax;
		MemFree(s_currentSyntaxObject->pszStr);
		s_currentSyntaxObject->pszStr = (yyvsp[0].pSyntax)->pszStr;
		(yyvsp[0].pSyntax)->pszStr = nullptr;
		delete (yyvsp[0].pSyntax);
	}
	else
	{
		s_currentSyntaxObject = (yyvsp[0].pSyntax);
	}
}
#line 2662 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 128:
#line 974 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_NOTIFTYPE;
   (yyval.pObject)->iAccess = (yyvsp[-4].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2682 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 129:
#line 995 "parser.y" /* yacc.c:1652  */
    {
   MP_SUBID *pSubId;

   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_TRAPTYPE;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);

   pSubId = new MP_SUBID;
   pSubId->pszName = (yyvsp[-4].pszString);
   (yyval.pObject)->pOID->add(pSubId);

   pSubId = new MP_SUBID;
   pSubId->pszName = (char *)MemAlloc(strlen((yyvsp[-4].pszString)) + 3);
   sprintf(pSubId->pszName, "%s#0", (yyvsp[-4].pszString));
   pSubId->bResolved = TRUE;
   (yyval.pObject)->pOID->add(pSubId);

   for(int i = 0; i < (yyvsp[0].pOID)->size(); i++)
      (yyval.pObject)->pOID->add((yyvsp[0].pOID)->get(i));
   (yyvsp[0].pOID)->setOwner(Ownership::False);
   delete (yyvsp[0].pOID);

   if (isupper((yyval.pObject)->pszName[0]))
   {
      Error(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2716 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 132:
#line 1033 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2724 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 137:
#line 1050 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2732 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 142:
#line 1071 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-4].pszString));
   delete (yyvsp[-3].pSyntax);
   MemFree((yyvsp[0].pszString));
}
#line 2742 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 143:
#line 1077 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2751 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 144:
#line 1085 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2759 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 146:
#line 1090 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2767 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 149:
#line 1104 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_OBJGROUP;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2782 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 150:
#line 1123 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
}
#line 2796 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 151:
#line 1141 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-6].pszString));
   MemFree((yyvsp[-3].pszString));
   delete (yyvsp[0].pOID);
}
#line 2806 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 155:
#line 1161 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2814 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 161:
#line 1185 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-6].pszString));
   delete (yyvsp[-5].pSyntax);
   MemFree((yyvsp[0].pszString));
}
#line 2824 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 164:
#line 1199 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-5].pszString));
   delete (yyvsp[-2].pList);
}
#line 2833 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 165:
#line 1204 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-3].pszString));
   delete (yyvsp[-1].pList);
}
#line 2842 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 166:
#line 1218 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-8].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-4].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_AGENTCAP;
   (yyval.pObject)->pszDescription = (yyvsp[-3].pszString);
   delete (yyval.pObject)->pOID;
   (yyval.pObject)->pOID = (yyvsp[0].pOID);
   MemFree((yyvsp[-5].pszString));
}
#line 2858 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 167:
#line 1233 "parser.y" /* yacc.c:1652  */
    {
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2867 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 168:
#line 1238 "parser.y" /* yacc.c:1652  */
    {
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2876 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 169:
#line 1243 "parser.y" /* yacc.c:1652  */
    {
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFree((yyvsp[0].pszString));
}
#line 2885 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 170:
#line 1248 "parser.y" /* yacc.c:1652  */
    {
   (yyval.nInteger) = 0;
}
#line 2893 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 171:
#line 1255 "parser.y" /* yacc.c:1652  */
    {
   static const char *pStatusText[] = { "mandatory", "optional", "obsolete", "deprecated", "current", NULL };
   int i;

   for(i = 0; pStatusText[i] != NULL; i++)
      if (!stricmp(pStatusText[i], (yyvsp[0].pszString)))
      {
         (yyval.nInteger) = i + 1;
         break;
      }
   if (pStatusText[i] == NULL)
   {
      char szBuffer[256];

      sprintf(szBuffer, "Invalid STATUS value \"%s\"", (yyvsp[0].pszString));
      mperror(szBuffer);
   }
   MemFree((yyvsp[0].pszString));
}
#line 2917 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 174:
#line 1283 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2925 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 175:
#line 1290 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2933 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 176:
#line 1297 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2941 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 177:
#line 1301 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
}
#line 2949 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 181:
#line 1311 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
}
#line 2957 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 182:
#line 1315 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
}
#line 2965 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 184:
#line 1320 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[0].pOID);
}
#line 2973 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 188:
#line 1333 "parser.y" /* yacc.c:1652  */
    {
   delete (yyvsp[-1].pList);
}
#line 2981 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 190:
#line 1341 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2989 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 191:
#line 1348 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 2997 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 192:
#line 1355 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3005 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 193:
#line 1362 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 3013 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 194:
#line 1366 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pImportList) = new ObjectArray<MP_IMPORT_MODULE>(16, 16, Ownership::True);
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 3022 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 195:
#line 1374 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pImports) = new MP_IMPORT_MODULE;
   (yyval.pImports)->pszName = (yyvsp[0].pszString);
   delete (yyval.pImports)->pSymbols;
   (yyval.pImports)->pSymbols = (yyvsp[-2].pList);
}
#line 3033 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 196:
#line 1384 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pList)->add((yyvsp[0].pszString));
}
#line 3041 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 197:
#line 1388 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pList) = new Array(16, 16, Ownership::True);
   (yyval.pList)->add((yyvsp[0].pszString));
}
#line 3050 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 198:
#line 1396 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3058 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 199:
#line 1400 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3066 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 200:
#line 1404 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3074 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 201:
#line 1411 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-1].pszString));
   delete (yyvsp[0].pSyntax);
}
#line 3083 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 209:
#line 1438 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[-2].pszString));
}
#line 3091 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 220:
#line 1458 "parser.y" /* yacc.c:1652  */
    {
   MemFree((yyvsp[0].pszString));
}
#line 3099 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 221:
#line 1465 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3107 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 222:
#line 1469 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3115 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 223:
#line 1476 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3123 "parser.tab.cpp" /* yacc.c:1652  */
    break;

  case 224:
#line 1483 "parser.y" /* yacc.c:1652  */
    {
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3131 "parser.tab.cpp" /* yacc.c:1652  */
    break;


#line 3135 "parser.tab.cpp" /* yacc.c:1652  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1496 "parser.y" /* yacc.c:1918  */


MP_MODULE *ParseMIB(const TCHAR *fileName)
{
   m_pModule = NULL;
   mpin = _tfopen(fileName, _T("r"));
   if (mpin != NULL)
   {
#ifdef UNICODE
	  WideCharToMultiByte(CP_ACP, WC_DEFAULTCHAR |WC_COMPOSITECHECK, fileName, -1, s_currentFilename, MAX_PATH, NULL, NULL);
#else
	  s_currentFilename = fileName;
#endif
      g_nCurrLine = 1;
      InitStateStack();
      /*mpdebug=1;*/
      ResetScanner();
      mpparse();
      fclose(mpin);
   }
   else
   {
#ifdef UNICODE
      char *name = MBStringFromWideString(fileName);
      Error(ERR_CANNOT_OPEN_FILE, name, strerror(errno));
      MemFree(name);
#else
      Error(ERR_CANNOT_OPEN_FILE, fileName, strerror(errno));
#endif
      return NULL;
   }
   return m_pModule;
}

extern "C" int mpwrap()
{
	return 1;
}

int mperror(const char *pszMsg)
{
   Error(ERR_PARSER_ERROR, s_currentFilename, pszMsg, g_nCurrLine);
   return 0;
}
